#include <WiFiManager.h> 
#include <WiFiClientSecure.h> 
WiFiClientSecure client;
// ----------------------------------
// ----------------------------------Programming Parameters START here and change ONLY these ------------------------------------------------------------
// ----------------------------------
#define AUTHORIZATION "testing-api"  // api key set
const float Latitude = 38.012108;   // latitude set
const float Longitude= 23.848103;     // longitude set 
const unsigned long minutes_time_interval = 1;  // time interval between measurements set in minutes
// ----------------------------------
// ----------------------------------Programming Parameters END here and change ONLY these ------------------------------------------------------------
// ----------------------------------
unsigned long previous_millis = 0;
void configModeCallback (WiFiManager *myWiFiManager) {
  Serial.println("Entered config mode");
  Serial.println(WiFi.softAPIP());
  //if you used auto generated SSID, print it
  Serial.println(myWiFiManager->getConfigPortalSSID());
  //entered config mode, make led toggle faster
}

void setup() {
  Serial.begin(115200);
  //-----------------------------------WIFI CONNECT -------------------
   WiFi.mode(WIFI_STA); // explicitly set mode, esp defaults to STA+AP
   WiFiManager wm;
  //reset settings - for testing
  // wm.resetSettings();
   wm.setAPCallback(configModeCallback);
   if (!wm.autoConnect()) {
    Serial.println("failed to connect and hit timeout");
    ESP.restart();
    delay(1000);
  }
  Serial.println("connected...yeey :)");
 //--------------------------END WIFI CONNECT ------------------
}
void loop() {
int sensorValue = analogRead(A0);
float test=(sensorValue-350);
float test1=1-(test/450);
float moisture=test1*100;
//-------------------------------------- YOU CAN CHANGE HERE ---------------------------------------------------------
//------------------------------------ Set here Latitude and Longitude -----------------------------------------------

//------------------------------------------ Until here to Set your Latitude and Longitude ----------------------------
  Serial.println(moisture);
  while (WiFi.status() != WL_CONNECTED) {
    Serial.println("Waiting for WiFi...");
    delay(1000);
  }
//--------------------------------Start of Server--------------------------------
 // Send the data to the server
  String dataJson = "{\"reading\":{\"station_id\":\"";
  dataJson += "station 1"; 
  dataJson += "\",\"moisture_value\":\"";
  dataJson += moisture;
  dataJson += "\",\"Latitude\":\"";
  dataJson += String(Latitude,6);
  dataJson += "\",\"Longitude\":\"";
  dataJson += String(Longitude,6);
  dataJson += "\"},\"battery\":\"";
  dataJson += "\"}";
Serial.print("DataJSON=");
Serial.println(dataJson);
client.setInsecure();
int status2 = client.connect("api.urbana.com.gr",443) ;
Serial.print("Client.connect()");
Serial.println(status2);
Serial.println(client.getLastSSLError());
    Serial.println("connected");
    client.print("POST /api/measurement HTTP/1.1\r\n");
    client.print("Host: api.urbana.com.gr\r\n");
    client.print("Connection: close\r\n");
//-------------------------------------- YOU CAN CHANGE HERE ---------------------------------------------------------
//------------------------------------ Set here your API key  --------------------------------------------------------
    client.print("api-key: ");
    client.print(AUTHORIZATION);
    client.print("\r\n");
//------------------------------------ Until here you can set your API key -----------------------------------------------
    client.print("Cache-Control: no-cache\r\n");
    client.print("Content-Type: application/json\r\n");
    client.print("Content-Length: ");
    client.println(dataJson.length() + 2);
    client.println("");
    client.println(dataJson);
    Serial.println(dataJson);
    delay(500);
    while (client.available()) {
      char c = client.read();
      Serial.print(c);
    }
    client.stop();
//------------------------------End of Server --------------------------------------------------------
  unsigned long current_millis = millis();
  while (current_millis <
         (previous_millis + (minutes_time_interval * 60 * 1000))) {
    delay(10000);
    current_millis = millis();
  }
  previous_millis = current_millis;
}
